﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;

namespace xamGridHeatmap
{
    class ColorConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            var collection = parameter as DataCollection;
            double max = collection.Max;
            double min = collection.Min;

            var val = (int)((CellControlBase)value).Cell.Value;

            double perRed = 0;
            double perGreen = 0;
            string color = "";
            double ratio = 0;

            ratio = 1 / (max - min);
            var finalValue = (val - min) * ratio;

            if (finalValue == 0.5)
            {
                perRed = 1;
                perGreen = 1;
            }
            else if (finalValue > 0.5)
            {
                perRed = 1;
                perGreen = (1 - finalValue) * 2;
            }
            else
            {
                perGreen = 1;
                perRed = finalValue * 2;
            }

            var red = (int)Math.Round(255.0 * perRed);
            var green = (int)Math.Round(255.0 * perGreen);
            var gString = green.ToString("X");
            var rString = red.ToString("X");

            if (gString.Length == 1)
            {
                gString = '0' + gString;
            }

            if (rString.Length == 1)
            {
                rString = rString + '0';
            }

            color = "#" + rString + gString + "00";

            return color;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
